unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, DB, ADODB, DBGrids, ImgList, Buttons,
  ExtCtrls, ToolWin ;

type
  PMyRec = ^TMyRec;
  TMyRec = Record
    PARENT_MENU_ID : Variant;
    MENU_ID : Variant;
    NAME : String;
    DESCRIPTION : String;
  end;

  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ADOConnection1: TADOConnection;
    DataSource1: TDataSource;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton7: TToolButton;
    Separator1: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    TreeView1: TTreeView;
    NAME: TEdit;
    DESCRIPTION: TEdit;
    ImageList1: TImageList;
    ADOQRY_MENUS: TADOQuery;
    ADOQRY_APPEND_MENU: TADOQuery;
    ADOQRY_DELETE_MENU: TADOQuery;
    ADOQRY_INSERT_MENU: TADOQuery;
    Memo1: TMemo;
    PARENT_MENU_ID: TEdit;
    MENU_ID: TEdit;
    Panel1: TPanel;
    ButtonFirst: TButton;
    ButtonUp: TButton;
    ButtonLeft: TButton;
    ButtonDown: TButton;
    ButtonRight: TButton;
    ButtonLast: TButton;
    ImageList2: TImageList;
    Separator2: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ADOQRY_CHECK_MENU: TADOQuery;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ButtonUpClick(Sender: TObject);
    procedure ButtonDownClick(Sender: TObject);
    procedure ButtonLeftClick(Sender: TObject);
    procedure ButtonRightClick(Sender: TObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure TreeView1Deletion(Sender: TObject; Node: TTreeNode);
    procedure ButtonLastClick(Sender: TObject);
    procedure ButtonFirstClick(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  WkTreeNode: TTreeNode;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    ADOConnection1.Connected := True;
//    ADOQRY_MENUS.Close;
//    ADOQRY_MENUS.Parameters.ParamValues['P_ID'] := 1;
//    ADOQRY_MENUS.Open;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    ADOConnection1.Connected := False;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
var
    MyTreeNode: TTreeNode;
    MyRecPtr: PMyRec;
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            New(MyRecPtr);
//            MyRecPtr^.PARENT_MENU_ID := StrToVar(PARENT_MENU_ID.Text);
//            MyRecPtr^.MENU_ID := StrToVar(MENU_ID.Text);
            MyRecPtr^.Name := NAME.Text;
            MyTreeNode := TreeView1.Items.AddObject(TreeView1.Selected,DESCRIPTION.Text,MyRecPtr);
            MyTreeNode.ImageIndex := 0;
            MyTreeNode.SelectedIndex := 1;
            MyTreeNode.StateIndex := -1;
        END;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
var
    MyTreeNode: TTreeNode;
    MyRecPtr: PMyRec;
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            New(MyRecPtr);
//            MyRecPtr^.PARENT_MENU_ID := StrToVar(PARENT_MENU_ID.Text);
//            MyRecPtr^.MENU_ID := StrToVar(MENU_ID.Text);
            MyRecPtr^.Name := NAME.Text;
            MyTreeNode := TreeView1.Items.AddChildObject(TreeView1.Selected,DESCRIPTION.Text,MyRecPtr);
            MyTreeNode.ImageIndex := 0;
            MyTreeNode.SelectedIndex := 1;
            MyTreeNode.StateIndex := -1;
        END;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            PMyRec(TreeView1.Selected.Data)^.Name := Name.Text;
            TreeView1.Selected.Text := Description.Text;
        END;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            TreeView1.Selected.Delete;
        END;
end;

procedure TForm1.ToolButton5Click(Sender: TObject);
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            IF WkTreeNode <> NIL THEN
                WkTreeNode.StateIndex := 0;
            TreeView1.Selected.StateIndex := 1;
            WkTreeNode := TreeView1.Selected;
        END;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            IF WkTreeNode <> NIL THEN
                WkTreeNode.StateIndex := 0;
            TreeView1.Selected.StateIndex := 2;
            WkTreeNode := TreeView1.Selected;
        END;
end;

procedure TForm1.ToolButton7Click(Sender: TObject);
    procedure InsertDetails(SRTreeNode,TGTreeNode : TTreeNode);
    var
        I : Integer;
        MyTreeNode : TTreeNode;
        MyRecPtr : PMyRec;
    begin
        IF TGTreeNode = TreeView1.Selected THEN
            BEGIN
                New(MyRecPtr);
                MyRecPtr^.PARENT_MENU_ID := PMyRec(TGTreeNode.Data)^.MENU_ID;
                MyRecPtr^.MENU_ID := PMyRec(SRTreeNode.Data)^.MENU_ID;
                MyRecPtr^.Name := PMyRec(SRTreeNode.Data)^.NAME;
                MyTreeNode := TreeView1.Items.AddChildObject(NIL,SRTreeNode.Text,MyRecPtr);
                MyTreeNode.ImageIndex := 0;
                MyTreeNode.SelectedIndex := 1;
                MyTreeNode.StateIndex := -1;
                InsertDetails(SRTreeNode,MyTreeNode);
                MyTreeNode.MoveTo(TGTreeNode,naAddChild);
            END
        ELSE
            BEGIN
                FOR I := 0 TO SRTreeNode.Count - 1 DO
                    BEGIN
                        New(MyRecPtr);
                        MyRecPtr^.PARENT_MENU_ID := PMyRec(TGTreeNode.Data)^.MENU_ID;
                        MyRecPtr^.MENU_ID := PMyRec(SRTreeNode[I].Data)^.MENU_ID;
                        MyRecPtr^.Name := PMyRec(SRTreeNode[I].Data)^.NAME;
                        MyTreeNode := TreeView1.Items.AddChildObject(TGTreeNode,SRTreeNode[I].Text,MyRecPtr);
                        MyTreeNode.ImageIndex := 0;
                        MyTreeNode.SelectedIndex := 1;
                        MyTreeNode.StateIndex := -1;
                        InsertDetails(SRTreeNode[I],MyTreeNode);
                   END;
           END;
    end;
begin
    IF ((WkTreeNode <> NIL) AND (TreeView1.Selected <> NIL)) THEN
        BEGIN
            CASE WkTreeNode.StateIndex OF
                1 : BEGIN // CUT
                        WkTreeNode.MoveTo(TreeView1.Selected,naAddChild);
                        WkTreeNode.StateIndex := 0;
                        WkTreeNode := NIL;
                    END;
                2 : BEGIN // COPY
                        InsertDetails(WkTreeNode,TreeView1.Selected);
                        WkTreeNode.StateIndex := 0;
                        WkTreeNode := NIL;
                    END;
            ELSE
                WkTreeNode.StateIndex := 0;
            END;
        END;
end;

procedure TForm1.ToolButton8Click(Sender: TObject);
var
    MyTreeNode: TTreeNode;
    MyRecPtr: PMyRec;
    procedure QueryDetails(ParentMenuID : Variant ; TreeNode : TTreeNode);
    var
        Details : TADOQuery;
        MyTreeNode : TTreeNode;
        MyRecPtr : PMyRec;
        ParentMenu : String;
    begin
        IF ((ParentMenuID = NULL) OR (ParentMenuID = UnAssigned)) THEN
            ParentMenu := '= -1'
        ELSE
            ParentMenu := '= ' + VarToStr(ParentMenuID);
        Details := TADOQuery.Create(Self);
        Details.Connection := ADOConnection1;
        Details.Close;
        Details.SQL.Clear;
        Details.SQL.Add('SELECT  PARENT_MENU_ID,' + #13 +
                        '        MENU_ID,' + #13 +
                        '        SEQNO,' + #13 +
                        '        NAME,' + #13 +
                        '        DESCRIPTION' + #13 +
                        'FROM    MENU' + #13 +
                        'WHERE   PARENT_MENU_ID ' + ParentMenu + #13 +
                        'ORDER BY' + #13 +
                        '        SEQNO');

        Details.Open;
        WHILE NOT Details.Eof DO
            BEGIN
                New(MyRecPtr);
                MyRecPtr^.PARENT_MENU_ID := Details.FieldByName('PARENT_MENU_ID').AsVariant;
                MyRecPtr^.MENU_ID := Details.FieldByName('MENU_ID').AsVariant;
                MyRecPtr^.Name := Details.FieldByName('NAME').AsString;
                MyTreeNode := TreeView1.Items.AddChildObject(TreeNode,Details.FieldByName('DESCRIPTION').AsString,MyRecPtr);
                MyTreeNode.ImageIndex := 0;
                MyTreeNode.SelectedIndex := 1;
                MyTreeNode.StateIndex := -1;
                QueryDetails(Details.FieldByName('MENU_ID').AsVariant,MyTreeNode);
                Details.Next;
           END;
        Details.Close;
        Details.Free;
    end;
begin
    TreeView1.Items.Clear;
    ADOQRY_MENUS.Close;
//    ADOQRY_MENUS.Parameters.ParamValues['P_PARENT_MENU_ID'] := 1;
    ADOQRY_MENUS.Open;
    WHILE NOT ADOQRY_MENUS.Eof DO
        BEGIN
            New(MyRecPtr);
            MyRecPtr^.PARENT_MENU_ID := ADOQRY_MENUS.FieldByName('PARENT_MENU_ID').AsVariant;
            MyRecPtr^.MENU_ID := ADOQRY_MENUS.FieldByName('MENU_ID').AsVariant;
            MyRecPtr^.NAME := ADOQRY_MENUS.FieldByName('NAME').AsString;
            MyTreeNode := TreeView1.Items.AddChildObject(NIL,ADOQRY_MENUS.FieldByName('DESCRIPTION').AsString,MyRecPtr);
            MyTreeNode.ImageIndex := 0;
            MyTreeNode.SelectedIndex := 1;
            MyTreeNode.StateIndex := -1;
            QueryDetails(ADOQRY_MENUS.FieldByName('MENU_ID').AsVariant,MyTreeNode);
            ADOQRY_MENUS.Next;
        END;
    ADOQRY_MENUS.Close;
    TreeView1.Items.Item[0].Expand(True);
end;

procedure TForm1.ToolButton9Click(Sender: TObject);
VAR
    M,D : Integer;
    V_SeqM,V_SeqD : Integer;
    Function DeleteDetails(ParentMenuID,MenuID : Variant) : Boolean;
    var
        Details : TADOQuery;
        ParentMenu : String;
    begin
        IF ((MenuID = NULL) OR (MenuID = UnAssigned)) THEN
            ParentMenu := '= -1'
        ELSE
            ParentMenu := '= ' + VarToStr(MenuID);
        Details := TADOQuery.Create(Self);
        Details.Connection := ADOConnection1;
        Details.Close;
        Details.SQL.Clear;
        Details.SQL.Add('SELECT  PARENT_MENU_ID,' + #13 +
                        '        MENU_ID' + #13 +
                        'FROM    MENU' + #13 +
                        'WHERE   PARENT_MENU_ID ' + ParentMenu + #13 +
                        'ORDER BY'  + #13 +
                        '        SEQNO');

        Details.Open;
        Result:= False;
        IF Details.IsEmpty THEN
            BEGIN
                ADOQRY_DELETE_MENU.Close;
//                ADOQRY_DELETE_MENU.Parameters.ParamByName('P_PARENT_MENU_ID').Value := VarToStr(ParentMenuID);
//                ADOQRY_DELETE_MENU.Parameters.ParamByName('P_MENU_ID').Value := VarToStr(MenuID);
                ADOQRY_DELETE_MENU.Parameters.Items[0].Value := ParentMenuID;
                ADOQRY_DELETE_MENU.Parameters.Items[1].Value := ParentMenuID;
                ADOQRY_DELETE_MENU.Parameters.Items[2].Value := MenuID;
                ADOQRY_DELETE_MENU.ExecSQL;
                Result := True;
                MEMO1.Lines.Add(VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[0].Value) + ',' + VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[1].Value)+ ',' + VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[2].Value));
            END
        ELSE
            BEGIN
                WHILE NOT Details.Eof DO
                    BEGIN
                        IF NOT DeleteDetails(Details.FieldByName('PARENT_MENU_ID').AsVariant,Details.FieldByName('MENU_ID').AsVariant) THEN
                            BEGIN
                                ADOQRY_DELETE_MENU.Close;
                                ADOQRY_DELETE_MENU.Parameters.Items[0].Value := Details.FieldByName('PARENT_MENU_ID').AsString;
                                ADOQRY_DELETE_MENU.Parameters.Items[1].Value := Details.FieldByName('PARENT_MENU_ID').AsString;
                                ADOQRY_DELETE_MENU.Parameters.Items[2].Value := Details.FieldByName('MENU_ID').AsString;
                                MEMO1.Lines.Add(VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[0].Value) + ',' + VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[1].Value)+ ',' + VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[2].Value));
                                ADOQRY_DELETE_MENU.ExecSQL;
                            END;
                        Details.Next;
                   END;
            END;
        Details.Close;
        Details.Free;
    end;
begin
    Memo1.Lines.Clear;
    V_SeqM := 1;
    FOR M := 0 TO TreeView1.Items.Count - 1 DO
        BEGIN
            IF (PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID = NULL) OR
               (PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID = UnAssigned)  THEN
                BEGIN // DELETE TREE FROM DATABASE
//                    IF PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID = UnAssigned THEN
//                        PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID := NULL;
                    IF NOT DeleteDetails(PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID,PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID) THEN
                        BEGIN
                            ADOQRY_DELETE_MENU.Close;
                            ADOQRY_DELETE_MENU.Parameters.Items[0].Value := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                            ADOQRY_DELETE_MENU.Parameters.Items[1].Value := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                            ADOQRY_DELETE_MENU.Parameters.Items[2].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                            MEMO1.Lines.Add(VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[0].Value) + ',' + VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[1].Value)+ ',' + VarToStr(ADOQRY_DELETE_MENU.Parameters.Items[2].Value));
                            ADOQRY_DELETE_MENU.ExecSQL;
                        END;
                    IF PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID = UnAssigned THEN
                        BEGIN // NEW ROOT
                            IF NOT ADOQRY_APPEND_MENU.Active THEN
                                BEGIN
                                    ADOQRY_APPEND_MENU.Close;
                                    ADOQRY_APPEND_MENU.Open
                                END;
                            ADOQRY_APPEND_MENU.Append;
                            IF TreeView1.Items.Item[M].Parent <> NIL THEN
                                PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID := PMyRec(TreeView1.Items.Item[M].Parent.Data)^.MENU_ID
                            ELSE
                                PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID := NULL;
                            ADOQRY_APPEND_MENU.FieldByName('PARENT_MENU_ID').AsVariant := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                            ADOQRY_APPEND_MENU.FieldByName('SEQNO').AsVariant := V_SeqM;
                            ADOQRY_APPEND_MENU.FieldByName('NAME').AsString := PMyRec(TreeView1.Items.Item[M].Data)^.Name;
                            ADOQRY_APPEND_MENU.FieldByName('DESCRIPTION').AsString := TreeView1.Items.Item[M].Text;
                            ADOQRY_APPEND_MENU.Post;
                            PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID := ADOQRY_APPEND_MENU.FieldByName('MENU_ID').AsVariant;
                            ADOQRY_APPEND_MENU.Close;
                        END
                    ELSE
                        BEGIN // OLD ROOT
                            ADOQRY_CHECK_MENU.Close;
                            ADOQRY_CHECK_MENU.Parameters.Items[0].Value := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                            ADOQRY_CHECK_MENU.Parameters.Items[1].Value := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                            ADOQRY_CHECK_MENU.Parameters.Items[2].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                            ADOQRY_CHECK_MENU.Open;
                            IF ADOQRY_CHECK_MENU.IsEmpty THEN
                                BEGIN
                                    ADOQRY_INSERT_MENU.Close;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_PARENT_MENU_ID').Value := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_MENU_ID').Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_SEQNO').Value := V_SeqM;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_NAME').Value := PMyRec(TreeView1.Items.Item[M].Data)^.NAME;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_DESCRIPTION').Value := TreeView1.Items.Item[M].Text;
{                                    ADOQRY_INSERT_MENU.Parameters.Items[0].Value := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.Items[1].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.Items[2].Value := V_SeqM;
                                    ADOQRY_INSERT_MENU.Parameters.Items[3].Value := PMyRec(TreeView1.Items.Item[M].Data)^.NAME;
                                    ADOQRY_INSERT_MENU.Parameters.Items[4].Value := TreeView1.Items.Item[M].Text;
                                    ADOQRY_INSERT_MENU.Parameters.Items[5].Value := PMyRec(TreeView1.Items.Item[M].Data)^.PARENT_MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.Items[6].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;}
                                    ADOQRY_INSERT_MENU.ExecSQL;
                                END;
                            ADOQRY_CHECK_MENU.Close;
                        END;
                    Inc(V_SeqM);
                END;
            V_SeqD := 1;
            FOR D := 0 TO TreeView1.Items.Item[M].Count - 1 DO
                BEGIN
                    IF PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.MENU_ID = UnAssigned THEN
                        BEGIN // NEW ENTRY
                            IF NOT ADOQRY_APPEND_MENU.Active THEN
                                BEGIN
                                    ADOQRY_APPEND_MENU.Close;
                                    ADOQRY_APPEND_MENU.Open
                                END;
                            ADOQRY_APPEND_MENU.Append;
                            PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.PARENT_MENU_ID := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                            ADOQRY_APPEND_MENU.FieldByName('PARENT_MENU_ID').AsVariant := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                            ADOQRY_APPEND_MENU.FieldByName('SEQNO').AsVariant := V_SeqD;
                            ADOQRY_APPEND_MENU.FieldByName('NAME').AsString := PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.Name;
                            ADOQRY_APPEND_MENU.FieldByName('DESCRIPTION').AsString := TreeView1.Items.Item[M].Item[D].Text;
                            ADOQRY_APPEND_MENU.Post;
                            PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.MENU_ID := ADOQRY_APPEND_MENU.FieldByName('MENU_ID').AsVariant;
                            ADOQRY_APPEND_MENU.Close;
                        END
                    ELSE
                        BEGIN //OLD ENTRY
                            ADOQRY_CHECK_MENU.Close;
                            ADOQRY_CHECK_MENU.Parameters.Items[0].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                            ADOQRY_CHECK_MENU.Parameters.Items[1].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                            ADOQRY_CHECK_MENU.Parameters.Items[2].Value := PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.MENU_ID;
                            ADOQRY_CHECK_MENU.Open;
                            IF ADOQRY_CHECK_MENU.IsEmpty THEN
                                BEGIN
                                    ADOQRY_INSERT_MENU.Close;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_PARENT_MENU_ID').Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_MENU_ID').Value := PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_SEQNO').Value := V_SeqD;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_NAME').Value := PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.NAME;
                                    ADOQRY_INSERT_MENU.Parameters.ParamByName('P_DESCRIPTION').Value := TreeView1.Items.Item[M].Item[D].Text;
{                                    ADOQRY_INSERT_MENU.Parameters.Items[0].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.Items[1].Value := PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.Items[2].Value := V_SeqD;
                                    ADOQRY_INSERT_MENU.Parameters.Items[3].Value := PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.NAME;
                                    ADOQRY_INSERT_MENU.Parameters.Items[4].Value := TreeView1.Items.Item[M].Item[D].Text;
                                    ADOQRY_INSERT_MENU.Parameters.Items[5].Value := PMyRec(TreeView1.Items.Item[M].Data)^.MENU_ID;
                                    ADOQRY_INSERT_MENU.Parameters.Items[6].Value := PMyRec(TreeView1.Items.Item[M].Item[D].Data)^.MENU_ID;}
                                    ADOQRY_INSERT_MENU.ExecSQL;
                                END;
                            ADOQRY_CHECK_MENU.Close;
                        END;
                    Inc(V_SeqD);
                END;
        END;
end;

procedure TForm1.TreeView1Click(Sender: TObject);
begin
    IF PMyRec(TTreeView(Sender).Selected.Data)^.PARENT_MENU_ID = UnAssigned THEN
        PARENT_MENU_ID.Text := ''
    ELSE
        PARENT_MENU_ID.Text := VarToStr(PMyRec(TTreeView(Sender).Selected.Data)^.PARENT_MENU_ID);
    MENU_ID.Text := VarToStr(PMyRec(TTreeView(Sender).Selected.Data)^.MENU_ID);
    NAME.Text := PMyRec(TTreeView(Sender).Selected.Data)^.Name;
    DESCRIPTION.Text := TTreeView(Sender).Selected.Text;
end;

procedure TForm1.ButtonFirstClick(Sender: TObject);
begin
    IF TreeView1.Selected <> NIL THEN
        TreeView1.Selected.MoveTo(TreeView1.Selected.Parent,naAddChildFirst);
end;

procedure TForm1.ButtonUpClick(Sender: TObject);
VAR
    I : Integer;
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            IF TreeView1.Selected.Parent <> NIL THEN
                BEGIN
                    IF TreeView1.Selected.Index > 0 THEN
                        BEGIN
                            TreeView1.Selected.MoveTo(TreeView1.Selected.Parent.Item[TreeView1.Selected.Index - 1],naInsert);
                        END;
                END
            ELSE
                BEGIN
                    FOR I := TreeView1.Selected.AbsoluteIndex - 1 DOWNTO 0 DO
                        BEGIN
                            IF TreeView1.Selected.Parent = TreeView1.Items.Item[I].Parent THEN
                                BEGIN
                                    TreeView1.Selected.MoveTo(TreeView1.Items.Item[I],naInsert);
                                    Exit;
                                END;
                        END;
                END;
        END;
end;

procedure TForm1.ButtonDownClick(Sender: TObject);
VAR
    I,J : Integer;
begin
    IF TreeView1.Selected <> NIL THEN
        BEGIN
            IF TreeView1.Selected.Parent <> NIL THEN
                BEGIN
                    IF (TreeView1.Selected.Index + 1) <= TreeView1.Selected.Parent.Count - 2 THEN
                        TreeView1.Selected.MoveTo(TreeView1.Selected.Parent.Item[TreeView1.Selected.Index + 2],naInsert)
                    ELSE IF (TreeView1.Selected.Index + 1) = TreeView1.Selected.Parent.Count - 1 THEN
                        TreeView1.Selected.MoveTo(TreeView1.Selected.Parent,naAddChild)
                    ELSE
                        NULL;
                END
            ELSE
                BEGIN
                    FOR I := TreeView1.Selected.AbsoluteIndex + 1 TO TreeView1.Items.Count - 1 DO
                        BEGIN
                            IF TreeView1.Selected.Parent = TreeView1.Items.Item[I].Parent THEN
                                BEGIN
                                    FOR J := I + 1 TO TreeView1.Items.Count - 1 DO
                                        BEGIN
                                            IF TreeView1.Selected.Parent = TreeView1.Items.Item[J].Parent THEN
                                                BEGIN
                                                    TreeView1.Selected.MoveTo(TreeView1.Items.Item[J],naInsert);
                                                    Exit;
                                                END;
                                        END;
                                    TreeView1.Selected.MoveTo(TreeView1.Selected.Parent,naAddChild);
                                    Exit;
                                END;
                        END;
                END;
        END;
end;

procedure TForm1.ButtonLastClick(Sender: TObject);
begin
    IF TreeView1.Selected <> NIL THEN
        TreeView1.Selected.MoveTo(TreeView1.Selected.Parent,naAddChild);
end;

procedure TForm1.ButtonLeftClick(Sender: TObject);
VAR
    I : Integer;
begin
    IF TreeView1.Selected <> NIL THEN
        IF TreeView1.Selected.Parent <> NIL THEN
            IF TreeView1.Selected.Parent.Parent <> NIL THEN
                BEGIN
                    FOR I := TreeView1.Selected.AbsoluteIndex + 1 TO TreeView1.Items.Count - 1 DO
                        BEGIN
                            IF TreeView1.Items.Item[I].Parent = TreeView1.Selected.Parent.Parent THEN
                                BEGIN
                                    TreeView1.Selected.MoveTo(TreeView1.Items.Item[I],naInsert);
                                    Exit;
                                END;
                        END;
                    TreeView1.Selected.MoveTo(TreeView1.Selected.Parent,naAdd);
                    Exit;
                END;
end;

procedure TForm1.ButtonRightClick(Sender: TObject);
VAR
    I,J : Integer;
begin
    IF TreeView1.Selected <> NIL THEN
        FOR I := TreeView1.Selected.AbsoluteIndex - 1 DOWNTO 0 DO
            BEGIN
                IF TreeView1.Items.Item[I].Parent = TreeView1.Selected.Parent THEN
                    BEGIN
                        FOR J :=  TreeView1.Items.Count - 1 DOWNTO I DO
                            BEGIN
                                IF TreeView1.Items.Item[J].Parent = TreeView1.Items.Item[I] THEN
                                    BEGIN
                                        TreeView1.Selected.MoveTo(TreeView1.Items.Item[I],naAddChild);
                                        Exit;
                                    END;
                            END;
                        TreeView1.Selected.MoveTo(TreeView1.Items.Item[I],naAddChild);
                        Exit;
                    END;
            END;
end;

procedure TForm1.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
    IF ((Sender.ClassNameIs('TTreeView')) AND (Source.ClassNameIs('TTreeView'))) THEN
        IF TTreeView(Sender).Name = TTreeView(Source).Name THEN
            Accept := True
        ELSE
            Accept := False
    ELSE
        Accept := False;
end;

procedure TForm1.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
VAR
    TGTreeNode : TTreeNode;
begin
    TGTreeNode := TTreeView(Sender).GetNodeAt(X,Y);
    TTreeView(Sender).Selected.MoveTo(TGTreeNode,naAddChild);
end;

procedure TForm1.TreeView1Deletion(Sender: TObject; Node: TTreeNode);
begin
    Dispose(Node.Data);
end;

end.
